// +++ Leonardo: FADING TAB +++ //

// Vorteingestellte Werte (35 - 97) entsprechen +-0dB in der DAW
int masterFaderDataByte1 = 35;
int masterFaderDataByte2 = 97;
int channelFaderDataByte1[] = {35, 35, 35, 35, 35, 35, 35, 35};
int channelFaderDataByte2[] = {97, 97, 97, 97, 97, 97, 97, 97};

// stepSize kontrolliert Geschwindigkeit und Präzisieon der Fader
// Mögliche Werte: 1, 2, 3, ..
int stepSize = 3;

/**
 * Fader des Masters
 */
void masterFading() {
  int encoderState = digitalRead(CHANNEL_CLK_PIN[8]);
  if(encoderState != encoderStateOld[8]) {
    bool clockwise = true;

    if (digitalRead(CHANNEL_DT_PIN[8]) != encoderState) {
      clockwise = false;
    }
    
    encoderStateOld[8] = encoderState;
  
    if (
         clockwise
      && masterFaderDataByte1 == 127
      && masterFaderDataByte2 < 127
    ) {
      // Zähle zweites Byte hoch bis maximal 127
      masterFaderDataByte2 = masterFaderDataByte2 + stepSize > 127 ? 127 : masterFaderDataByte2 + stepSize;
    
    } else if (
         !clockwise
      && masterFaderDataByte1 == 0
      && masterFaderDataByte2 > 0
    ) {
      // Zähle zweites Byte runter bis minimal 0
      masterFaderDataByte2 = masterFaderDataByte2 - stepSize < 0 ? 0 : masterFaderDataByte2 - stepSize;
    
    }
    
    // Wechsel erstes Byte zwischen 0 und 127
    if (
         ( clockwise && (masterFaderDataByte2 != 127))
      || (!clockwise && (masterFaderDataByte2 != 0))
    ) {
      masterFaderDataByte1 = masterFaderDataByte1 == 0 ? 127 : 0;
    }

    sendMidiPitchwheel(232, masterFaderDataByte1, masterFaderDataByte2);
  }
}

/**
 * Fader der Kanäle
 */
void channelFading() {
  for (int i = 0; i < 8; i++) {
    int encoderState = digitalRead(CHANNEL_CLK_PIN[i]);

    if(encoderState != encoderStateOld[i]) {
      bool clockwise = true;

      if (digitalRead(CHANNEL_DT_PIN[i]) == encoderState) {
        clockwise = false;
      }

      encoderStateOld[i] = encoderState;

      if (
        clockwise
        && channelFaderDataByte1[i] == 127
        && channelFaderDataByte2[i] < 127
      ) {
        // Zähle zweites Byte hoch bis maximal 127
        channelFaderDataByte2[i] = channelFaderDataByte2[i] + stepSize > 127 ? 127 : channelFaderDataByte2[i] + stepSize;
      } else if (
        !clockwise
        && channelFaderDataByte1[i] == 0
        && channelFaderDataByte2[i] > 0
      ) {
        // Zähle zweites Byte runter bis minimal 0
        channelFaderDataByte2[i] = channelFaderDataByte2[i] - stepSize < 0 ? 0 : channelFaderDataByte2[i] - stepSize;
      }

      // switch 1st byte between 0 and 127
      if (
           (clockwise && (channelFaderDataByte2[i] != 127))
        || (!clockwise && (channelFaderDataByte2[i] != 0)) 
      ) {
        channelFaderDataByte1[i] = channelFaderDataByte1[i] == 0 ? 127 : 0;
      }

      sendMidiPitchwheel(224 + i, channelFaderDataByte1[i], channelFaderDataByte2[i]);
    }
  }
}
