// +++ Leonardo: HAUPT TAB +++ //

#include "MIDIUSB.h"
#include <Wire.h>

/** Input Pins deklarieren */
const int CHANNEL_CLK_PIN[] = {0, 4, 6, 8, 10 , 12, A0, A2, A4};
const int CHANNEL_DT_PIN[] = {1, 5, 7, 9, 11, 13, A1, A3, A5};

/** Globale Variablen deklarieren */
bool encoderStateOld[] = {0, 0, 0, 0, 0, 0, 0, 0, 0};
byte recordStates[] = {0, 0, 0, 0, 0, 0, 0, 0};
byte soloStates[] = {0, 0, 0, 0, 0, 0, 0, 0};
byte muteStates[] = {0, 0, 0, 0, 0, 0, 0, 0};
byte globalPlayState = 0;
byte globalRecordState = 0;
bool encoderIsPanning = true;

void setup() {
  // In I2C Bus registrieren als Slave mit Adresse #8
  Wire.begin(8);

  // I2C Events registrieren
  Wire.onReceive(receiveEvent);
  Wire.onRequest(requestEvent);

  // Setup Pin Modus
  for(int a = 0; a < 9; a++) {
    pinMode(CHANNEL_CLK_PIN[a], INPUT);
    pinMode(CHANNEL_DT_PIN[a], INPUT);
  }

  // Hilfskonstrukt, um LED Status aus der DAW zu erhalten
  delay(3000);
  sendMidi(144, 49, 127);
  sendMidi(144, 48, 127);
}

void loop() {
  // MIDI Daten von DAW abhören
  receiveMidi();

  // Master Fader verarbeiten
  masterFading();

  // Channel Panning oder Fading verarbeiten
  // in Abhängigkeit zum Encoder-Status
  if (encoderIsPanning) {
    channelPanning();
  } else {
    channelFading();
  }
}
