// +++ Leonardo: I2C TAB +++ //

/**
 * I2C Event-Methode bei Empfang
 * einer Nachricht vom Master
 */
void receiveEvent() {
  byte buffer[3];
  
  while (Wire.available()) {
 
    // Wir erwarten 3 Bytes
    for (int p = 0; p < 3; p++) {
      buffer[p] = Wire.read();
    }

    // Interner Status Befehl?
    if (buffer[0] == 0) {
      if (buffer[1] == 0) {
        // encoder state
        // 0 - 0 - 0 panning
        // 0 - 0 - 1 fading
        encoderIsPanning = buffer[2] == 0 ? true : false;
      }
    } else {
      // Sende Daten als MIDI-Befehl zur DAW
      sendMidi(buffer[0], buffer[1], buffer[2]); 
    }
  }

  // Buffer leeren
  buffer[0] = 0;
  buffer[1] = 0;
  buffer[2] = 0;
}

/**
 * I2C Event-Methode sendet Daten
 * bei Anfrage vom Master
 */
void requestEvent() {
  // send all button states
  // that will be 26 bytes alltogether
  byte sendBuffer[26];
  for (int i = 0; i < 8; i++) {
    sendBuffer[i] = recordStates[i];
  }
  for (int i = 8; i < 16; i++) {
    sendBuffer[i] = soloStates[i - 8];
  }
  for (int i = 16; i < 24; i++) {
    sendBuffer[i] = muteStates[i - 16];
  }
  sendBuffer[24] = globalPlayState;
  sendBuffer[25] = globalRecordState;

  Wire.write(sendBuffer, 26);
}
