// +++ Leonardo: MIDI_RECEIVE TAB +++ //

/**
 * Empfangen und Verarbeiten von 3 MIDI Bytes
 */
void receiveMidi() {  
  midiEventPacket_t rx;
  do {
    rx = MidiUSB.read();

    // Prüfung, ob MIDI Daten eingehen …
    if (rx.header != 0) {

      // nur erwartete Notes empfangen
      if ((int) rx.byte1 == 144) {
        int channel;
        byte state = (int) rx.byte3 == 127 ? 1 : 0;

        // Master Wiedergabe
        if ((int) rx.byte2 == 94) {
          globalPlayState = state;
        }

        // Master Aufnahme
        if ((int) rx.byte2 == 95) {
          globalRecordState = state;
        }

        // Kanal Aufnahme (Byte 2: 0 bis 7)
        if ((int) rx.byte2 >= 0 && (int) rx.byte2 < 8) {
          channel = (int) rx.byte2;
          recordStates[channel] = state;
        }
        
        // Kanal Solo (Byte 2: 8 bis 15)
        if ((int) rx.byte2 >= 8 && (int) rx.byte2 < 16) {
          channel = (int) rx.byte2 - 8;
          soloStates[channel] = state;
        }

        // Kanal Mute (Byte2: 16 bis 23)
        if ((int) rx.byte2 >= 16 && (int) rx.byte2 < 24) {
          channel = (int) rx.byte2 - 16;
          muteStates[channel] = state;
        }

      }
    }
  } while (rx.header != 0);
}
