// +++ Mega: BUTTONS TAB +++ //

// Buttons
int playButtonStateOld = 0;
int recordButtonStateOld = 0;
int channelRecordStateOld[] = {0, 0, 0, 0, 0, 0, 0, 0};
int channelSoloStateOld[] = {0, 0, 0, 0, 0, 0, 0, 0};
int channelMuteStateOld[] = {0, 0, 0, 0, 0, 0, 0, 0};

/**
 * Aufnahme Taster der Kanäle
 */
void checkRecordButtons() {
  for (int i = 0; i < 8; i++) {
    int channelRecordState = digitalRead(CHANNEL_RECORD_PINS[i]);

    if (channelRecordState != channelRecordStateOld[i]) {
      if (channelRecordState) {
        sendI2C(144, 0 + i, 127);
      }

      channelRecordStateOld[i] = channelRecordState;
    }
  }
}

/**
 * Solo Taster der Kanäle
 */
void checkSoloButtons() {
  for (int i = 0; i < 8; i++) {
    int channelSoloState = digitalRead(CHANNEL_SOLO_PINS[i]);

    if (channelSoloState != channelSoloStateOld[i]) {
      if (channelSoloState) {
        sendI2C(144, 8 + i, 127);
      }

      channelSoloStateOld[i] = channelSoloState;
    }
  }
}

/**
 * Mute Taster der Kanäle
 */
void checkMuteButtons() {
  for (int i = 0; i < 8; i++) {
    int channelMuteState = digitalRead(CHANNEL_MUTE_PINS[i]);

    if (channelMuteState != channelMuteStateOld[i]) {
      if (channelMuteState) {
        sendI2C(144, 16 + i, 127);
      }

      channelMuteStateOld[i] = channelMuteState;
    }
  }
}

/**
 * Master Wiedergabe/Stopp Taster 
 * Sendet in Abhängigkeit der globalen Variable globalPlayState
 * Befehl zur Wiedergabe oder Stopp an DAW
 */
void checkGlobalPlayButton() {

  int playButtonState = digitalRead(GLOBAL_PLAY_PIN);

  // button state changed
  if (playButtonState != playButtonStateOld) {
    if (playButtonState) {
      // we only need information, when button is pressed
      // we don't care of the button release
      byte firstByte = globalPlayState == 1 ? 93 : 94;

      // send MIDI command
      sendI2C(144, firstByte, 127);
    }

    playButtonStateOld = playButtonState;
  }
}

/**
 * Master Aufnahme Taster
 * Sendet Befehl zum Starten/Stoppen der Aufnahme
 */
void checkGlobalRecordButton() {
  int recordButtonState = digitalRead(GLOBAL_RECORD_PIN);

  // button state changed
  if (recordButtonState != recordButtonStateOld) {
    if (recordButtonState) {
      // send MIDI command
      sendI2C(144, 103, 127);
    }

    recordButtonStateOld = recordButtonState;
  }
}
