// +++ Mega: HAUPT TAB +++ //

#include <Wire.h>

/** Input Pins deklarieren */
const int CHANNEL_RECORD_PINS[] = {A0, A1, A2, A3, A4, A5, A6, A7};
const int CHANNEL_SOLO_PINS[] = {5, 4, 3, 2, 1, 0, 14, 15};
const int CHANNEL_MUTE_PINS[] = {13, 12, 11, 10, 9, 8 ,7 ,6};

const int ENCODER_SWITCH_PINS[] = {A8, A9, A10, A11, A12, A13, A14, A15};

const int GLOBAL_RECORD_PIN = 16;
const int GLOBAL_PLAY_PIN = 17;
const int BANK_SWITCH_UP_PIN = 19;
const int BANK_SWITCH_DOWN_PIN = 18;

/** Output Pins deklarieren */
const int LED_GLOBAL_PLAY = 25;
const int LED_GLOBAL_RECORD = 23;
const int LED_CHANNEL_RECORD[] = {36, 34, 32, 30, 28, 26, 24, 22};
const int LED_CHANNEL_SOLO[] = {52, 50, 48, 46, 44, 42, 40, 38};
const int LED_CHANNEL_MUTE[] = {53, 51, 49, 47, 45, 43, 41, 39};

/** Globale Variablen deklarieren */
byte globalPlayState = 0;
byte globalRecordState = 0;
byte recordStates[] = {0, 0, 0, 0, 0, 0, 0, 0};
byte soloStates[] = {0, 0, 0, 0, 0, 0, 0, 0};
byte muteStates[] = {0, 0, 0, 0, 0, 0, 0, 0};

void setup() {
  // In I2C Bus registrieren als Master
  Wire.begin();

  // Setup Pin Modus
  pinMode(GLOBAL_PLAY_PIN, INPUT);
  pinMode(GLOBAL_RECORD_PIN, INPUT);
  pinMode(BANK_SWITCH_UP_PIN, INPUT);
  pinMode(BANK_SWITCH_DOWN_PIN, INPUT);

  for (int i = 0; i < 8; i++) {
    pinMode(ENCODER_SWITCH_PINS[i], INPUT);
    pinMode(CHANNEL_SOLO_PINS[i], INPUT);
    pinMode(CHANNEL_MUTE_PINS[i], INPUT);
    pinMode(CHANNEL_RECORD_PINS[i], INPUT);

    pinMode(LED_CHANNEL_RECORD[i], OUTPUT);
    pinMode(LED_CHANNEL_SOLO[i], OUTPUT);
    pinMode(LED_CHANNEL_MUTE[i], OUTPUT);
  }
}

void loop() {
  // Button Status verarbeiten
  checkEncoderSwitches();
  checkBankSwitches();
  checkGlobalPlayButton();
  checkGlobalRecordButton();
  checkRecordButtons();
  checkSoloButtons();
  checkMuteButtons();
  
  // LED Status von Slave abfragen
  requestFromSlave();
}
